private var beingDragged : Draggable;
private var moving : boolean;

var speed : float = 0.3;
var park : boolean;

////create path with linrenderer
var lineWidth = 0.02;
var lineMaterial: Material;
private var line : LineRenderer;

////create a array for the objects movements
private var routePoints : Array = new Array();
var station : Transform;

function Start()
{
    ///create the vars for the line
    lineObject = new GameObject("Line");
    line = lineObject.AddComponent(LineRenderer);
    line.SetWidth(lineWidth, lineWidth);
    line.material = lineMaterial;
    line.SetVertexCount(0);
    park = false;
}

function AddPoint(point : Vector3)
{
    ///update line and add to the array start the move function
    routePoints.Add(point);
	UpdateLine(routePoints);
    if(!moving)
    {
        Move(routePoints);
    }
}

function RemoveLastPoint()
{
    //remove the arrays last element
    routePoints.Pop();
}

function GetLastPoint() : Vector3
{
    //returns the arrays last element
    routePoints[routePoints.length-1];
}

function Reset()
{
    ///clear the array i have started the touch move began
    routePoints.length = 0;
    moving = false;
}

function Move(trail : Array)
{
    ///this is the move function where the magic lives :)
    moving = true;
    UpdateLine(trail);
	
    // this loop steps through each point remaining in the array
    while (trail.length > 1)
    {
        var thisPoint : Vector3 = trail[0];
        var nextPoint : Vector3 = trail[1];
        dist = (thisPoint - nextPoint).magnitude;
        lerpDist = 0.0;

        // this loop smoothly moves the object from the current point to the next
        while (lerpDist < dist)
		{
            i = lerpDist / dist;
			
			//Debug.Log("Moving to "+nextPoint);
            transform.position = Vector3.Lerp(thisPoint, nextPoint, i);
            transform.LookAt(nextPoint);
            if (moving)
            {
                yield;
            }else
            {
                return;
            }
            lerpDist += Time.deltaTime * speed;
        }
        if (trail.length > 0)
        {
            trail.Shift();
			transform.position = nextPoint;
        }

        UpdateLine(trail);
    }
	
    moving = false;
	if (park == true)
	{
		Park(transform);
	}
}

function Update()
{
    if (!moving && !park)
    {
        ///move staight on if no arrays
        transform.Translate(Vector3.forward * Time.deltaTime* speed);	
    }
}

function Park(ParkObject : Transform)
{
	///park up next to the station and wait 5 secs
	ParkObject.LookAt(station);
	yield new WaitForSeconds (5);
	
	////now to turn around and move forward again
	ParkObject.Rotate(0,180,0);
   	park = false;
}


function UpdateLine(trail: Array)
{
    ///update line vector count
    line.SetVertexCount(trail.length);
    var i = 0;
    for (var drawLine : Vector3 in trail)
    {
        //Debug.Log(drawLine);
        ///loop over the array and appply the line
        line.SetPosition(i, drawLine);
        i++;
    }
}