private var draggedObject : Draggable;
private var xyPlane : Plane;
public var snapItems : Transform[];

var snapDistance : float;
var wasSnapped : boolean;
var snap : boolean;
var snapZPos : float = 0.5;
var itemRadius : float = 1;

function Start()
 {
	//create a invisable plane for hit
	xyPlane = new Plane(Vector3.up, Vector3.zero);
}

function Update()
{
    if(iPhoneInput.touchCount >= 1)
    {
        touch = iPhoneInput.touches[0];

        if(touch.phase == iPhoneTouchPhase.Began)
        {
			snap = false;
			
            // determine whether a draggable object was touched,
            // if so, put it in "draggedObject"
            //cast a ray from camera to touch position
            var detectRay : Ray = Camera.main.ScreenPointToRay(Vector3(touch.position.x, touch.position.y));
            var hit : RaycastHit;
            if(Physics.Raycast(detectRay, hit))
            {
				Debug.Log(hit.transform.name);
                draggedObject = hit.transform.GetComponent(Draggable);
                if (draggedObject)
                {
                    draggedObject.Reset();
                }
            }
        }

        if(touch.phase == iPhoneTouchPhase.Moved)
        {
            // if currently dragging an object, send the current point to the object
            // (so the object adds it to its own internal array of points to move through)
            //Create a ray
            var mouseRay : Ray = Camera.main.ScreenPointToRay(iPhoneInput.GetTouch(0).position);
            var distance : float;
			
			var snapOffset : Vector3 = Vector3(0, 0, snapZPos);
			
            ///check if hit	
            if(xyPlane.Raycast(mouseRay, distance))
			{
                var hitPoint : Vector3 = mouseRay.GetPoint(distance);
            }

            if(draggedObject != null)
            {
                //check whether we hit a station
                for(var item : Transform in snapItems)
                {
					snapOffset = item.rotation*Vector3(0, 0, snapZPos);
					
                    // check z and x postion
                    var xDistance = Mathf.Abs(hitPoint.x - item.position.x - snapOffset.x);
                    var zDistance = Mathf.Abs(hitPoint.z - item.position.z - snapOffset.z);
					
                    ///check using mirror always abaute tech mathf.abs to check if close inuff <<< misspelt LOL
                    if(xDistance < snapDistance && zDistance < snapDistance)
                    {
                        //.. we are near enough to snap on the X axis ..
                        Debug.Log("we are this close to " + item.name + " " + xDistance + " " + zDistance);
                        var snapPos : Vector3 = item.position;

						///set station as snapped item
						draggedObject.station = item;

                        ///change y for true position
                        snapPos.y = draggedObject.transform.position.y;

                        //set snap to true as we have found a local snap position
                        snap = true;
                    }
                }
				
                if(!snap)
                {
                    wasSnapped = false;
                    hitPoint.y = 0.5;
                    draggedObject.AddPoint(hitPoint);
                }else
                {
                    if(!wasSnapped)
                    {
						///set up the position just before to stop before the arrow
						snapPos += snapOffset;
                        Debug.Log("snap to this " + snapPos);
						
						//Remove positions intersecting the station
						var waypos : Vector3 = draggedObject.GetLastPoint();
						var dir : Vector3 = waypos-draggedObject.station.position;
						var dist : float = Mathf.Sqrt(dir.x*dir.x+dir.z*dir.z);
						while(dist < itemRadius)
						{
							draggedObject.RemoveLastPoint();
							waypos = draggedObject.GetLastPoint();
							dir = waypos-draggedObject.station.position;
							dist = Mathf.Sqrt(dir.x*dir.x+dir.z*dir.z);
						}
						
						//Find out the angle between the vectors pointing from waypoint to station center and snappos to station center
						dir.y = 0;
						snapOffset.y = 0;
						dir.Normalize();
						snapOffset.Normalize();
						var cos : float = Vector3.Dot(dir, snapOffset);
						var angle : float = Mathf.Acos(cos);
						var sin : float = snapOffset.x;
						snapOffset.x = -snapOffset.z;
						snapOffset.z = snapOffset.x;
						var side : float = Vector3.Dot(snapOffset, dir);
						for(angle = angle-Mathf.Min(0.5, angle); angle != 0; angle -= Mathf.Min(0.5, angle))
						{
							cos = Mathf.Cos(angle)*2*itemRadius;
							sin = Mathf.Sin(angle)*2*itemRadius*side;
							draggedObject.AddPoint(draggedObject.station.rotation*Vector3(cos , 0, sin));
						}
						
						draggedObject.park = true;
						draggedObject.AddPoint(snapPos);
                        wasSnapped = true;
                    }
                }
            }
        }

        if(touch.phase == iPhoneTouchPhase.Ended)
        {
            snap = false;
            count = 0;
            draggedObject = null;
        }
    }
}
